function updateBricks()
	pickUpBricks()
	moveProjectiles()
	collideBricksWithMapBorder()
	collideBricksWithEnemies()
	collideWithPlayer()
end

function pickUpBricks()
	for i, b in ipairs(bricks) do
		if math.dist(b.x+16,b.y+16, player.x+(player.w/2),player.y+(player.h/2)) < 32 then
			player.bricks = player.bricks + 1
			table.remove(bricks,i)
			
			playS(s_blip,settings.volume*0.3,math.random(1050,1200)/1000)
			screen:shake(3)
		end
	end
end

function moveProjectiles()
	for i, p in ipairs(projectiles) do
		p.x = p.x + (math.cos(p.dir)*p.speed*hdt)
		p.y = p.y + (math.sin(p.dir)*p.speed*hdt)
	end
end

function collideBricksWithMapBorder()
	for i, p in ipairs(projectiles) do
		if p.friendly then
			p.w = 20
			p.h = 20
			local hit = false
			
			if p.x < map.x then
				p.x = map.x
				hit = true
			end
			if p.x+p.w > map.x+map.w+15 then
				p.x = map.x+map.w-p.w-15
				hit = true
			end
			if p.y < map.y-(p.h/3*2) then
				p.y = map.y-(p.h/3*2)
				hit = true
			end
			if p.y+p.h+12 > map.y+map.h then
				p.y = map.y+map.h-p.h-12
				hit = true
			end
			
			if hit and p.friendly then
				newB = {x=p.x,y=p.y-15,id=p.brickId,img=p.img} table.insert(bricks,newB)
				table.remove(projectiles,i)
				playS(s_hit2,settings.volume*0.3,math.random(900,1100)/1000)
				screen:shake(3)
			end
		end
	end
end

function collideBricksWithEnemies()
	for j, e in ipairs(enemies) do
		for i, p in ipairs(projectiles) do
			if collision(e.x,e.y,e.anim.img:getHeight()*2,e.anim.img:getHeight()*2, p.x-(p.img:getWidth()/2),p.y-(p.img:getHeight()/2),p.img:getWidth(),p.img:getHeight()) and p.friendly and e.z == 0 then
				if p.pass ~= true then
					newB = {x=p.x,y=p.y-15,id=p.brickId,img=p.img} table.insert(bricks,newB)
					table.remove(projectiles,i)
				else
					love.timer.sleep(1/30)
				end
				playS(s_hit2,settings.volume,math.random(900,1100)/1000)
				e.health = e.health - 1
			end
		end
	end
end

function collideWithPlayer()
	for i, p in ipairs(projectiles) do
		if p.friendly ~= true then
			local f = 10
			if collision(player.x+(f/2),player.y+(f/2),player.w-f,player.h-f, p.x-(p.img:getWidth()/2),p.y-(p.img:getHeight()/2),p.img:getWidth(),p.img:getHeight()) and player.iTimer <= 0 then
				table.remove(projectiles,i)
				player.health = player.health - 1
				player.iTimer = player.iTimerMax
				playS(s_hit,settings.volume*0.4,math.random(900,1100)/1000)
				screen:setRotation(.09)
			end
		end
	end
end