function updateEnemies()
	spawnEnemies()
	enemyBehaviour()
	setEnemyInvert()
	damagePlayerOnContact()
	killEnemies()
	updateGibs()
	enemyBorderCollision()
end

function enemyBehaviour()
	for i, e in ipairs(enemies) do
		if e.id == "grunt" then
			e.dir = math.angle(e.x,e.y, player.x,player.y)
			e.speed = 145 
			e.health = e.health or 1
			e.deathImg = i_gruntDead
			e.reward = 10
			e.anim = e.anim or newAnim(a_grunt.img,a_grunt.playTime)
			
			if e.z == 0 then
				e.x = e.x + (math.cos(e.dir)*e.speed*hdt)
				e.y = e.y + (math.sin(e.dir)*e.speed*hdt)
			end
		end
		
		if e.id == "ranged" then
			e.dirOffset = e.dirOffset or math.rad(math.random(-45,45))
			e.dir = e.dir or math.rad(math.random(0,360))
			if math.dist(e.x,e.y,player.x,player.y) < 250 then
				e.dir = math.angle(e.x,e.y, player.x,player.y) + math.rad(180) + e.dirOffset
			end
			e.speed = 75
			e.health = e.health or 1
			e.deathImg = i_rangedDead
			e.reward = 15
			e.anim = e.anim or newAnim(a_ranged.img,a_ranged.playTime)
			e.timer = e.timer or 2
			e.timer = e.timer + hdt
			
			if e.timer < 3 and e.z == 0 then
				e.x = e.x + (math.cos(e.dir)*e.speed*hdt)
				e.y = e.y + (math.sin(e.dir)*e.speed*hdt)
			end
			if e.timer > 3 then
				e.dir = math.angle(e.x+20,e.y+20, player.x,player.y)
			end
			if e.timer > 3.6 then
				newP = {x=e.x+20,y=e.y+20,dir = e.dir,friendly=false, img = i_enemyBrick, speed=350, brickId="default"}table.insert(projectiles,newP)
				e.timer = 0
				e.dir = math.angle(e.x,e.y, player.x,player.y) + math.rad(math.random(-90,90))
			end
		end
			
		if e.id == "aoe" then
			e.dirOffset = e.dirOffset or math.rad(math.random(-45,45))
			e.dir = e.dir or math.rad(math.random(0,360))
			e.speed = 100
			e.health = e.health or 1
			e.deathImg = i_aoeDead
			e.reward = 15
			e.anim = e.anim or newAnim(a_aoe.img,a_aoe.playTime)
			e.timer = e.timer or 2
			e.timer = e.timer + hdt
			
			if e.timer < 5 and e.z == 0 then
				e.x = e.x + (math.cos(e.dir)*e.speed*hdt)
				e.y = e.y + (math.sin(e.dir)*e.speed*hdt)
			end
			if e.timer > 5 then
				e.dir = math.angle(e.x+20,e.y+20, player.x,player.y)
			end
			if e.timer > 5.6 then
				for j=1,3 do
					newP = {x=e.x+20,y=e.y+20,dir = math.rad(math.random(0,360)),friendly=false, img = i_enemyBrick, speed=200, brickId="default"}table.insert(projectiles,newP)
				end
				e.timer = 0
				e.dir = math.angle(e.x,e.y, player.x,player.y) + math.rad(math.random(-90,90))
			end
		end
		
	end
end

function setEnemyInvert()
	for i, e in ipairs(enemies) do
		if math.cos(e.dir) < 0 then
			e.invert = -1
			e.xOffset = 40
		else
			e.invert = 1
			e.xOffset = 0
		end
	end
end

function damagePlayerOnContact()
	for i, e in ipairs(enemies) do
		local f = 20
		if collision(e.x+(f/2),e.y+(f/2),e.anim.img:getHeight()*2-f,e.anim.img:getHeight()*2-f, player.x,player.y,player.w,player.h) and player.iTimer <= 0 and e.z == 0 then
			player.health = player.health - 1
			player.iTimer = player.iTimerMax
			playS(s_hit,settings.volume*0.4,math.random(900,1100)/1000)
			screen:setRotation(.09)
		end
	end
end

function killEnemies()
	for i, e in ipairs(enemies) do
		if e.health <= 0 then
			newC = {x=e.x,y=e.y,img=e.deathImg} table.insert(corpses,newC)
			table.remove(enemies,i)
			
			for j=0,15 do
				local img = i_gib
				local rand = math.random(1,4)
				if rand == 1 then
					img = i_gib2
				elseif rand == 2 then
					img = i_gib3
				elseif rand == 3 then
					img = i_gib4
				elseif rand == 4 then
					img = i_gib5
				end
				
				newG = {x=e.x+8,y=e.y+8,img=img, dir=math.rad(math.random(0,360)), speed = math.random(40,80), z=0,zVec=math.random(120,300), r=math.rad(math.random(0,360)), rSpeed = math.random(-400,400)/1000} table.insert(gibs,newG)
			end
			
			player.score = player.score + e.reward
			
			playS(s_splat,settings.volume*20, math.random(800,1100)/1000)
			screen:zoom(0.93)
			screen:setShake(8)
			love.timer.sleep(1/30)
		end
	end
end

function enemyBorderCollision()
	for i, p in ipairs(enemies) do
		p.w = 60
		p.h = 60
	
		if p.x < map.x then
			p.x = map.x
		end
		if p.x+p.w > map.x+map.w+15 then
			p.x = map.x+map.w-p.w+15
		end
		if p.y < map.y then
			p.y = map.y
		end
		if p.y+p.h > map.y+map.h then
			p.y = map.y+map.h-p.h
		end
	end
end

function updateGibs()
	for i, g in ipairs(gibs) do
		g.z = g.z + (g.zVec*hdt)
		g.zVec = g.zVec - (500*hdt)
		
		g.x = g.x + (math.cos(g.dir)*g.speed*hdt)
		g.y = g.y + (math.sin(g.dir)*g.speed*hdt)
		
		g.r = g.r + (g.rSpeed*hdt)
		
		if g.z < 0 then
			lg.setCanvas(c_gore)		--MY EYES!!!!
			lg.setColor(1,1,1)
			lg.draw(i_deathPuddle,g.x-map.x,g.y-map.y, 0, 2,2)
			lg.setCanvas()
			
			local rand = math.random(1,3)
			local sound = s_splat2
			
			if rand == 2 then
				sound = s_splat3
			elseif rand == 3 then
				sound = s_splat4
			end
			
			playS(sound,settings.volume*0.75,math.random(800,1200)/1000)
			
			table.remove(gibs,i)
		end
	end
end

function spawnEnemies()
	spawnTimer = spawnTimer or 0
	spawnCounter = spawnCounter or 0
	local rand = math.random(1,3)
	local id = "grunt"
	spawnTimer = spawnTimer - hdt
	
	if rand == 2 then
		id = "ranged"
	elseif rand == 3 then
		id = "aoe"
	end
	
	if spawnTimer <= 0 and getTableCount(enemies) <= 3+(spawnCounter/4) then
		spawnTimer = 1
		spawnCounter = spawnCounter + 1
		newE = {x=math.random(map.x,map.x+map.w),y=math.random(map.y,map.y+map.h),z=720, id=id} table.insert(enemies,newE)
	end
	
	local decent = 300
	for i,e in ipairs(enemies) do
		e.z = e.z - ((decent+100*(1/e.z*500))*hdt)
		if e.z < 0 then
			e.z = 0
		end
	end
end