function loadFunctions()	
	function math.dist(x1,y1,x2,y2)
		return ((x2-x1)^2+(y2-y1)^2)^0.5 
	end
	
	function math.angle(x1,y1, x2,y2)
		return math.atan2(y2-y1, x2-x1)
	end
	
	function collision(x1,y1,w1,h1, x2,y2,w2,h2)
		return x1 < x2+w2 and
		   y1 < y2+h2 and
		   x2 < x1+w1 and
		   y2 < y1+h1
	end
	
	function separateRects(x1,y1,w1,h1, x2,y2,w2,h2)
		local rx,ry = x1,y1
		local diff = w2
		
		if collision(x1,y1,w1,h1, x2,y2,w2,h2) then
			if x1+w1 - x2 < diff then
				diff = x1+w1 - x2
				rx,ry = x2-w1,y1
			end
			if y1+h1 - y2 < diff then
				diff = y1+h1 - y2
				rx,ry = x1,y2-h1
			end
			if x2+w2 - x1 < diff then
				diff = x2+w2 - x1
				rx,ry = x2+w2,y1
			end
			if y2+h2 - y1 < diff then
				rx,ry = x1,y2+h2
			end
			
		end
		
		return rx,ry
	end
	
	function getTableCount(t)
		local c=0
		for i, o in ipairs(t) do
			c=c+1
		end
		return c
	end
	
	function playS(sound,volume,pitch,minPitch)
		pitch = pitch or 1
		if minPitch == nil then
			minPitch = 0.1
		end
		if pitch < minPitch then
			pitch = minPitch
		end
		s = sound:clone()
		s:setVolume(volume)
		s:setPitch(pitch)
		
		love.audio.play(s)

	end
end