function updatePlayer()
	gameOver()
	attractBricks()
	movePlayer()
	playerBorderCollision()
	invertPlayer()
	throwBrick()
	reducePlayerITimer()
end


function movePlayer()
	if lm.isDown(2) and player.health > 0 and player.bricks > 0 then
		player.speed = 150
	end

	local angle = -1
	
	if lk.isDown("w") then
		angle = math.rad(270)
	end
	if lk.isDown("d") then
		angle = 0
	end
	if lk.isDown("s") then
		angle = math.rad(90)
	end
	if lk.isDown("a") then
		angle = math.rad(180)
	end
	
	if lk.isDown("w") and lk.isDown("a") then
		angle = math.rad(270-45)
	end
	if lk.isDown("w") and lk.isDown("d") then
		angle = math.rad(270+45)
	end
	if lk.isDown("s") and lk.isDown("a") then
		angle = math.rad(90+45)
	end
	if lk.isDown("s") and lk.isDown("d") then
		angle = math.rad(90-45)
	end
	
	if lk.isDown("a") and lk.isDown("d") or lk.isDown("w") and lk.isDown("s") then
		angle = -1
	end
	
	if angle ~= -1 then
		player.x = player.x + (math.cos(angle)*player.speed*hdt)
		player.y = player.y + (math.sin(angle)*player.speed*hdt)
	end
end

function playerBorderCollision()
	if player.x < map.x then
		player.x = map.x
	end
	if player.x+player.w > map.x+map.w then
		player.x = map.x+map.w-player.w
	end
	if player.y < map.y-(player.h/3*2) then
		player.y = map.y-(player.h/3*2)
	end
	if player.y+player.h+12 > map.y+map.h then
		player.y = map.y+map.h-player.h-12
	end
end

function invertPlayer()
	if mouse.x < player.x+(player.w/2) then
		player.invert = -1
		player.xOffset = player.w
	else
		player.invert = 1
		player.xOffset = 0
	end
end

function throwBrick()
	if lm.isDown(1) or lm.isDown(2) and player.chargeShotTimer >= player.chargeShotMax then
		if player.bricks > 0 and player.health > 0 then
			local pass = false
			if lm.isDown(2) and player.chargeShotTimer >= player.chargeShotMax then
				pass = true
				player.chargeShotTimer = 0
			end
		
			player.bricks = player.bricks - 1
			newP = {x=player.x+(player.w/2),y=player.y+(player.h/2),dir = math.angle(player.x+(player.w/2),player.y+(player.h/2), mouse.x,mouse.y),friendly=true, img = player.brickImg, speed=1500, brickId=player.brickId, pass=pass}table.insert(projectiles,newP)
			playS(s_fire,settings.volume*0.5,math.random(800,1200)/1000)
			screen:shake(7)
			screen:zoom(0.98)
		end
	end
	
	if lm.isDown(2) and player.health > 0 and player.bricks > 0 then
		player.chargeShotTimer = player.chargeShotTimer + hdt
		if player.chargeShotTimer > 1 then
			player.chargeShotTimer = 1
		end
		screen:zoom(1+(player.chargeShotTimer/30))
	else
		player.chargeShotTimer = player.chargeShotTimer - (hdt*2)
		if player.chargeShotTimer < 0 then
			player.chargeShotTimer = 0
		end
		
	end
end

function reducePlayerITimer()
	player.iTimer = player.iTimer - hdt
end

function attractBricks()
	if lk.isDown("space") and player.health > 0 then
		player.speed = 100
		for i, b in ipairs(bricks) do
			local angle = math.angle(b.x,b.y,player.x,player.y)
			local speed = 300
			b.x = b.x + (math.cos(angle)*speed*hdt)
			b.y = b.y + (math.sin(angle)*speed*hdt)
		end
		screen:zoom(1.02)
	end
end

function gameOver()
	if player.health <= 0 then
		player.speed = 0
		hdt = 0
		s_music:stop()
		for i, e in ipairs(enemies) do
			e.z = 1
		end
		
		if lk.isDown("r") then
			player.health = 3
			spawnTimer = 0
			spawnCounter = 0
			enemies = {}
			bricks = {}
			projectiles = {}
			corpses = {}
			gibs = {}
			player.bricks = 1
			player.x = 1280/2
			player.y = 720/2
			player.score = 0
			c_gore = lg.newCanvas(map.w,map.h)
			
			la.play(s_music)
		end
	else
		player.speed = 400
	end
end