function drawWorld()
	drawBg()
	drawGore()
	drawShadows()
	drawCorpses()
	drawPlayer()
	drawBricks()
	drawEnemies()
	drawProjectiles()
	drawHud()
	drawEndScreen()
	
end

function drawBg()
	if player.health >= 3 then
		lg.setBackgroundColor(65/255,215/255,215/255)
	elseif player.health == 2 then
		lg.setBackgroundColor(255/255,170/255,50/255)
	elseif player.health == 1 then
		lg.setBackgroundColor(215/255,45/255,45/255)
	else
		lg.setBackgroundColor(75/255,20/255,60/255)
	end
	
	
	
	for i=80,1280-160,80 do
		for j=80,720-160,80 do
			lg.setColor(1,1,1)
			lg.draw(i_bgTile,i,j, 0, 2,2)
		end
	end
end

function drawPlayer()
	if player.health <= 0 then
		lg.setColor(1,1,1)
		lg.draw(i_playerCorpse,player.x,player.y, 0, 2,2)
	else
		if player.iTimer > 0 then
			local f = math.sin(globalTimer*15)/3.7+0.7
			lg.setColor(1,1,1,f)
		else
			lg.setColor(1,1,1)
		end
			
		if lk.isDown("w","s","a","d") then
			lg.draw(play(a_playerRun),player.x+player.xOffset,player.y, 0, 2*player.invert,2)
		else
			lg.draw(play(a_playerIdle),player.x+player.xOffset,player.y, 0, 2*player.invert,2)
		end
		
		if player.bricks > 0 then
			local angle = math.angle(player.x+(player.w/2),player.y+(player.h/2), mouse.x,mouse.y)
			local dist = 15-(player.chargeShotTimer*4)
			local f2 = 1+(player.chargeShotTimer*0.2)
			lg.draw(player.brickImg, player.x+(player.w/2)+(math.cos(angle)*dist),player.y+(player.h/2)+(math.sin(angle)*dist), angle, 2*player.invert*f2,2*f2, player.brickImg:getWidth()/2,player.brickImg:getHeight()/2)
		end
	end
end

function drawBricks()
	for i, b in ipairs(bricks) do
		lg.setColor(1,1,1)
		lg.draw(b.img, b.x,b.y+(math.sin(globalTimer*4)*3), 0, 2,2)
	end
end

function drawProjectiles()
	for i, p in ipairs(projectiles) do
		if p.pass then
			lg.setColor(1,0.4,0.4)
		else
			lg.setColor(1,1,1)
		end
		lg.draw(p.img,p.x,p.y, p.dir+math.rad(45), 2,2, p.img:getWidth()/2,p.img:getHeight()/2)
	end
end

function drawEnemies()
	for i, e in ipairs(enemies) do
		lg.setColor(1,1,1)
		lg.draw(play(e.anim),e.x+e.xOffset,e.y-e.z, 0, 2*e.invert,2)
	end
end

function drawShadows()
	lg.setColor(1,1,1,0.4)
	
	for i, b in ipairs(bricks) do
		lg.draw(i_shadow, b.x-2,b.y+10, 0, 2,2)
	end
	for i, e in ipairs(enemies) do
		local f = 1+(e.z/800)
		lg.draw(i_shadow, e.x+20,e.y+20+20, 0, 2*f,2*f, i_shadow:getWidth()/2,i_shadow:getHeight()/2)
	end
	lg.draw(i_shadow, player.x,player.y+20, 0, 2,2)
end

function drawCorpses()
	for i, c in ipairs(corpses) do
		lg.setColor(1,1,1)
		lg.draw(c.img,c.x,c.y, 0, 2,2)
	end
end

function drawHud()	
	lg.origin()
	lg.scale(lg.getWidth()/1280,lg.getHeight()/720)

	lg.setColor(0,0,0,0.3)
	lg.rectangle('fill',0,0,1280,60)

	lg.setColor(1,1,1)
	for i=0,player.health-1 do
		lg.draw(i_playerHealth, 20+(50*i),10, 0, 2,2)
	end
	
	lg.setColor(1,1,1)
	lg.draw(i_crosshair,mouse.x,mouse.y, 0, 2,2, i_crosshair:getWidth()/2,i_crosshair:getHeight()/2)
	
	lg.scale(1280/lg.getWidth(),720/lg.getHeight())
	lg.setCanvas(c_text)
	lg.clear()
	lg.setColor(170/255,20/255,60/255)
	lg.print("Score: ".. player.score, 450,11, 0, 3/20,3/20)
	lg.setColor(240/255,105/255,35/255)
	lg.print("Score: ".. player.score, 450,10, 0, 3/20,3/20)
	lg.setCanvas()
	lg.scale(lg.getWidth()/1280,lg.getHeight()/720)
	
	lg.setColor(1,1,1)
	lg.draw(c_text,0,0, 0, 2,2)
end

function drawEndScreen()
	if player.health <= 0 then
		lg.setColor(0,0,0,0.65)
		lg.rectangle("fill",0,0,1280,720)
		lg.setColor(0,0,0,0.3)
		lg.rectangle("fill",0,0,450,720)
		
		lg.scale(1280/lg.getWidth(),720/lg.getHeight())
		lg.setCanvas(c_end)
		
		lg.clear()
		lg.setColor(120/255,145/255,165/255)
		lg.print("Game Over",5,7, 0, 1/3,1/3)
		lg.setColor(200/255,225/255,235/255)
		lg.print("Game Over",5,5, 0, 1/3,1/3)
		
		lg.setColor(170/255,20/255,60/255)
		lg.print("Score: "..player.score, 5,52, 0, 2/7,2/7)
		lg.setColor(240/255,105/255,35/255)
		lg.print("Score: "..player.score, 5,50, 0, 2/7,2/7)
		
		
		lg.setColor(15/255,115/255,115/255)
		lg.print("Press   'R'",5,332, 0, 1/4,1/4)
		lg.setColor(115/255,255/255,115/255)
		lg.print("Press   'R'",5,330, 0, 1/4,1/4)
		
		lg.setCanvas()
		lg.scale(lg.getWidth()/1280,lg.getHeight()/720)
		
		lg.setColor(1,1,1)
		lg.draw(c_end,0,0, 0, 2,2)
	end
	
	--moved here from gore
	lg.scale(1280/lg.getWidth(),720/lg.getHeight())
	lg.setCanvas(c_gore)
	
	for i, g in ipairs(gibs) do
		if g.z <= 0 then
			lg.draw(i_deathPuddle,g.x-map.x,g.y-map.y, 0, 2,2)
		end
	end

	lg.setCanvas()
	--lg.scale(lg.getWidth()/1280,lg.getHeight()/720)
end

function drawGore()

	lg.setColor(1,1,1)
	lg.draw(c_gore,map.x,map.y)
	
	for i, g in ipairs(gibs) do
		lg.setColor(0.9,0.9,0.9)
		lg.draw(g.img,g.x,g.y-g.z, g.r, 2,2, 5,5)
	end
	
end