lg = love.graphics
lk = love.keyboard
la = love.audio
lm = love.mouse

screen = require "libs/shack"

require "bin/assets"
require "bin/functions"
require "bin/player"
require "bin/bricks"
require "bin/enemies"
require "bin/animationsystem"
require "bin/render/drawWorld"

player = {x=1280/2,y=720/2, w=40,h=40, health=3,bricks=1,speed=400, invert=1,xOffset=0, brickId = "default", iTimer=0,iTimerMax=2,score=0,chargeShotTimer=0,chargeShotMax = 0.65}
map = {x=80,y=80,w=1280-160,h=720-160}
settings = {volume = 1}
mouse = {x=0,y=0}
bricks = {}
projectiles = {}
enemies = {}
corpses = {}
gibs = {}

globalTimer = 0

function love.load()
	lg.setDefaultFilter("nearest","nearest")
	lm.setVisible(false)
	
	loadAssets()
	loadFunctions()
	
	player.brickImg = i_defaultBrick
	
	s_music:setLooping(true)
	la.play(s_music)
end

function love.update(dt)
	hdt = dt
	globalTimer = globalTimer + hdt
	
	mouse.x = lm.getX()
	mouse.y = lm.getY()
	
	updatePlayer()
	updateEnemies()
	updateBricks()
	
	screen:update(dt)
	
	if lk.isDown("escape") then
		love.event.quit()
	end
end

function love.draw(dt)
	screen:apply()
	drawWorld()
end

function love.keypressed(key, scancode, isrepeat)
   if key == "f" then
		if love.window.getFullscreen() == true then
			love.window.setFullscreen(false, "desktop")
		else
			love.window.setFullscreen(true, "desktop")
		end
   end
end

